"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const style_1 = __importDefault(require("./style"));
const IconButton_1 = __importDefault(require("../IconButton"));
const Confirm_1 = __importDefault(require("../Confirm"));
const UploadImages_1 = __importDefault(require("../UploadImages"));
const Button_1 = __importDefault(require("../Button"));
const ImagePreview_1 = __importDefault(require("../ImagePreview"));
const UploadView = ({ images = [], maxLen = 0, title = '图片上传', onChange, }) => {
    const onPreview = (index) => {
        (0, ImagePreview_1.default)({
            index,
            images
        });
    };
    const onDelete = (index) => {
        (0, Confirm_1.default)({
            message: '确定删除该图片吗？',
            scrollView: false,
            textAlign: 'center',
            onSubmit: () => {
                const imgs = images.filter((v, k) => {
                    if (k !== index)
                        return v;
                });
                onChange === null || onChange === void 0 ? void 0 : onChange(imgs);
            }
        });
    };
    const onUpload = () => {
        (0, UploadImages_1.default)({
            title,
            maxLen,
            onChange: (img) => {
                onSubmit(img);
            }
        });
    };
    const onSubmit = (res) => __awaiter(void 0, void 0, void 0, function* () {
        onChange === null || onChange === void 0 ? void 0 : onChange((images || []).concat(res));
    });
    return (react_1.default.createElement(react_native_1.View, { style: style_1.default.container }, images === null || images === void 0 ? void 0 :
        images.map((v, k) => {
            return (react_1.default.createElement(Button_1.default, { key: `img_${k}`, styleContainer: style_1.default.imagesItem, onPress: () => {
                    onPreview(k);
                } },
                react_1.default.createElement(react_native_1.Image, { style: style_1.default.imagesUrl, source: { uri: v } }),
                react_1.default.createElement(IconButton_1.default, { name: 'close', size: 14, color: '#fff', styleContainer: style_1.default.imagesDel, onPress: () => {
                        onDelete(k);
                    } })));
        }),
        react_1.default.createElement(react_native_1.View, { style: style_1.default.upload },
            react_1.default.createElement(IconButton_1.default, { name: 'add', size: 40, color: '#bbb', styleContainer: style_1.default.uploadBtn, onPress: onUpload }))));
};
exports.default = UploadView;
